// AnalogInputTrigger_AI_Scan_Cplusplus.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <atlstr.h>
#include "..\Lib\HSDAQ.h"
#pragma comment(lib,"..\\Lib\\HSDAQ.lib")

int ReplaceChar(char *srcStr,char r, char t)
{
	int len=strlen(srcStr);
	int i;
	if(len)
	{
		for(i=0;i<len;i++)
		{
			if(srcStr[i]==r)
				srcStr[i]=t;
		}	
	}
	return 0;
}
unsigned WStrlen(LPTSTR wideStr)
{
	unsigned length = WideCharToMultiByte(CP_ACP, 0, wideStr, -1, 0, 0, NULL, NULL);
	return length;
}

void WideToChar(LPTSTR wideStr, char cStr[])
{
	unsigned length = WStrlen(wideStr);
	char* output = new char[length];
	WideCharToMultiByte(CP_ACP, 0, wideStr, -1, output , length,NULL,NULL);
	strcpy(cStr, output);
	delete[] output;
}
void CharToWide(LPCSTR astr, LPTSTR wstr)
{
	MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, astr, -1, wstr, 2048);
}

HANDLE hHS;
char IP[20],ConnectConfig[30],str[50];
long Databuff[30000000];

void CharToWide(LPCSTR astr, LPTSTR wstr);

int _tmain(int argc, _TCHAR* argv[])
{
	int temp;
	bool ret = false;
	char str[50];
	int ch = 0;
	short ChCnt = 0;
	short Gain = 0;
	short TrigMode = 6; //6 : Analog Input Mode
	long sampleRate = 0;
	unsigned long targetCnt = 0;
	short DataTransMethod = 0;
	short AutoRun = 0;
	unsigned int Status = 0;
	unsigned int readsize = 0;
	unsigned long totalRecv = 0;
	unsigned long Reserv = 0;
	unsigned int i = 0;
	int analogmode=-1;
	int file_count=0;
	char En_Channel[4];
	float hightriglevel[4];
	float lowtriglevel[4];
	unsigned long leftsidecnt=0;
	unsigned long rightsidecnt=0;
	CString infoBuf="";
	char LOG_PATH[MAX_PATH];
	TCHAR TC_LOG_PATH[MAX_PATH];
	TCHAR File_Full_Path[MAX_PATH]={0};
	HANDLE ofile;


	GetCurrentDirectory( MAX_PATH, TC_LOG_PATH );
	WideToChar(TC_LOG_PATH,LOG_PATH);


	printf("PET-AR400 Analog Threshold Trigger demo\n");
	printf("Please input IP (xxx.xxx.xxx.xxx) !!\n");
	while(1)
	{
		scanf("%s",IP);
		sprintf(ConnectConfig,"%s,9999,10010",IP);
		hHS = HS_Device_Create(ConnectConfig);
		if (hHS < 0)
		{
			printf("Invalid IP, please input again.\n");
		}
		else
		{
			Sleep(100);
			break;
		}
	}
	HS_GetSDKVersion(str);
	printf("HSDAQ SDK Version = %s\n", str);
	HS_GetFirmwareVersion(hHS,str);
	printf("PET-AR400 Firmware Versoin = %s\n",str);
	/* For details, please refer to the API manual
     * AI CH input Range : 1 ~ 4
     * Gain Range        : 0
     * Mode Range        : 0 B 6
     * Sample rate       : 
     *  ch=1    : 12.8k/16k/32k/64k/128k Hz
     *  ch=2    : 12.8k/16k/32k/64k Hz
     *  ch=3/4  : 12.8k/16k/32k Hz
     * targetcnt         : 0 (continue mode)
     * AI trigger mode   : 0 ~ 3
     *    0:  Above
          1:  Below
          2:  Out-Range
          3:  In-Range
    */
	printf("Please input number of channels for sample data(1 ~ 4)\n");
	scanf("%d",&ChCnt);
	printf("[check]%d\r\n",ChCnt);

	printf("Please Select AI range\n");
	printf("[0] +/- 10V\r\n");
	scanf("%d",&Gain);

	printf("Please input sample rate:\r\nch=1    : 12.8k/16k/32k/64k/128k Hz\r\nch=2    : 12.8k/16k/32k/64k Hz\r\nch=3/4  : 12.8k/16k/32k Hz\n");
	scanf("%ld",&sampleRate);
	printf("[check]%ld\r\n",sampleRate);

	printf("Please input Target Count(1 ~ 30000000)\n");
	scanf("%lu",&targetCnt);
	printf("[check]%lu\r\n",targetCnt);

	printf("Please input Analog Input Trigger Mode\n");
	printf("0 : Above\n");
	printf("1 : Below\n");
	printf("2 : Out-Range\n");
	printf("3 : In-Range\n");
	scanf("%d",&analogmode);

	printf("Enable/Disable the channels for AI trigger\n");
	printf("0 : disable\n");
	printf("1 : enable\n");
	for(ch=0;ch<ChCnt;ch++)
	{
		printf("Channel %d \n",ch);
		scanf("%d",&En_Channel[ch]);
	}

	printf("Input high limit for each channel\n");
	switch(Gain)
	{
		case 0:
			printf("Range : +/- 10V\n");
			break;
	}
	for(ch=0;ch<ChCnt;ch++)
	{
		if(En_Channel[ch]==1)
		{
			printf("Channel %d \n",ch);
			scanf("%f",&hightriglevel[ch]);
		}
	}

	printf("Input low limit for each channel\n");
	switch(Gain)
	{
		case 0:
			printf("Range : +/- 10V\n");
			break;
	}
	for(ch=0;ch<ChCnt;ch++)
	{
		if(En_Channel[ch]==1)
		{
			printf("Channel %d \n",ch);
			scanf("%f",&lowtriglevel[ch]);
		}
	}

	printf("Input 'Before-Trigger-Counts' and 'After-Trigger-Counts','Before-Trigger-Counts' and 'After-Trigger-Counts' must add up to be equal to 'Target Count'\r\n");
	while(1)
	{
		printf("Input the counts that need to read before trigged\n");
		scanf("%lu",&leftsidecnt);

		printf("Input the counts that need to read after trigged\n");
		scanf("%lu",&rightsidecnt);

		if((leftsidecnt+rightsidecnt)!=targetCnt)
		{
			printf("'Before-Trigger-Counts' and 'After-Trigger-Counts' is not equal to 'Target Count'\nPlease input parameters again\n\n");
		}
		else
			break;
	}
	printf("[c2]%d\r\n",ChCnt);
	ret = HS_SetAIScanParam(hHS, ChCnt, Gain, TrigMode, sampleRate, targetCnt, DataTransMethod, AutoRun);
	if (!ret)
	{
		printf("Set AI Scan : Ch count = %d ,Gain = %d ,TrigMode = %d ,sampleRate = %lu ,targetCnt = %lu\n",ChCnt,Gain,TrigMode,sampleRate,targetCnt);
		printf("HS_SetAIScanParam failed Error code1 0x%x \n", HS_GetLastError());
		return 0;
	}
	ret = HS_SetAIAnalogTriggerParam(hHS,analogmode,En_Channel,hightriglevel,lowtriglevel,ChCnt,leftsidecnt,rightsidecnt,0);
	if (!ret)
	{
		printf("HS_SetAIAnalogTriggerParam failed Error code1 0x%x",HS_GetLastError());
		return 0;
	}
	else
	{
		HS_GetAIScanParam(hHS, &ChCnt, &Gain, &TrigMode, &sampleRate, &targetCnt, &DataTransMethod, &AutoRun);
		HS_GetAIAnalogTriggerParam(hHS,&analogmode,En_Channel,hightriglevel,lowtriglevel,ChCnt,&leftsidecnt,&rightsidecnt,&Reserv);
		printf("Set AI Scan : Ch count = %d Gain = %d TrigMode = %d sampleRate = %lu targetCnt = %lu\n",ChCnt,Gain,TrigMode,sampleRate,targetCnt);
		printf("Analog Input Trigger Mode = %d Before-Trigger-Counts = %lu After-Trigger-Counts = %lu\n",analogmode,leftsidecnt,rightsidecnt);
		for(ch=0;ch<ChCnt;ch++)
		{
			if(En_Channel[ch]==1)
				printf("CH %d Enable High Limit %2.3f Low Limit %2.3f\n",ch,hightriglevel[ch],lowtriglevel[ch]);
			else
				printf("CH %d Disable High Limit %2.3f Low Limit %2.3f\n",ch,hightriglevel[ch],lowtriglevel[ch]);
		}
		HS_StartLogger(hHS,LOG_PATH, 2, 0);//0:bin file, 1:txt file
		if (!ret)
		{
			printf("HS_StartAIScan failed Error code1 0x%x \n", HS_GetLastError());
			return 0;
		}
		while (1)
        {
            ret = HS_GetTotalSamplingStatus(hHS, &totalRecv,&Status);
			if (ret == false)
			{
				printf("Error code3 0x%x",HS_GetLastError());
			}
            else
			{
				if ((Status >>7)&0x01 == 1)
				{
					break;
				}
				else if ((Status >>2)&0x01 == 1)
				{
					printf("[error] AD_DATA_SAMPLING_TIMEOUT \n");
					break;
				}
				else if ((Status >>1)&0x01 == 1)
				{
					printf("[error] AD_BUF_OVERFLOW \n");
					break;
				}
				else if ((Status & 0x01) == 0x01)
				{
					printf("Received Count : %lu Status :%X\r",totalRecv,Status);
				}
				else
				{
					printf("Sampling Count : %lu Status :%X\r",totalRecv,Status);
				}
			}
			Sleep(10);
        }
		HS_StopLogger(hHS);	
	}
	HS_Device_Release(hHS);

	ReplaceChar(IP,'.','_');
	strcat(LOG_PATH,"\\log\\");
	strcat(LOG_PATH,IP);
	printf("\r\npath=%s\r\n",LOG_PATH);
	CharToWide(LOG_PATH,TC_LOG_PATH);


	file_count=HS_GetAllLogFilesW(TC_LOG_PATH,0);
	if(file_count>0)
	{
		ofile=HS_LogFile_Open_byIndexW(file_count-1,File_Full_Path);
		ret=HS_GetLogFile_AIDataHex(ofile,0,targetCnt,Databuff);

		for (i = 0; i < totalRecv; i++)
		{
			float fdata;
			HS_Calibrate_Data_Float(ofile,i%ChCnt,Gain,Databuff[i],&fdata);
			if (i % ChCnt == ChCnt - 1) 
			{
				printf("%lf\r\n", fdata);
			}
			else 
			{
				printf("%lf,", fdata);
			}
		}
		printf("\r\nAP total read = %lu\r\n",totalRecv );
		printf("\n");
		HS_LogFile_Close(ofile);
	}
	else
	{
		printf("No File!\r\n");
	}
	printf("Press any key to quit program");
	getchar();
	return 0;
}

