// Analog_Input_Scan.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "HSDAQ.h"
#include <stdio.h>
#include <conio.h>

int _tmain(int argc, _TCHAR* argv[])
{
	HANDLE hHS;
	char IPadd[64]="\0";
	char sdk_version[16]={0};
	char fw_version[32]={0};

	bool ret= false;
	short chCnt=4;
	short  useGain=0;


	short extriggMode=0;
	bool continuousMode=false;
	long continuousTimeout=0;
	unsigned long targetCnt=0;
	long sampleRate=0;

	//unsigned long totalRead=0,totalReceived=0;
	short DataTransMethod=0;
	short AutoRun=0;

	if(argc>1)
	{
		wprintf(TEXT("%s\r\n"),argv[1]);
		//char   *pFilePathName; 
   
		//int   nLen   =   wcslen(argv[1])+1;    
		WideCharToMultiByte(CP_ACP,   0,   argv[1],   -1,   IPadd,  64,   NULL,   NULL);
		printf("program start %s\r\n",IPadd);
	}
	else
	{
		printf("error argument\r\n");
		return 0;
	}

	char tmp[128]={0};
	sprintf(tmp,"%s,9999,10010",IPadd);
	//Step 1: Create a TCP connection with PET-AR400
	hHS = HS_Device_Create(tmp);

	Sleep(10);
	if(hHS!=NULL)
	{
		printf("PET-AR400 Analog Input Scan Testing [N sample mode & Software trigger]\r\n");
		HS_GetSDKVersion(sdk_version);
		printf("HSDAQ SDK Ver=%s\r\n",sdk_version);

		HS_GetFirmwareVersion(hHS,fw_version);
		printf("PET-AR400 Firmware Ver=%s\r\n",fw_version);
		/* For details, please refer to the API manual
		 * AI CH input Range : 1 ~ 4
		 * Gain Range        : 0(+/-10V)
		 * Mode Range        : 0 B 6
		 * Sample rate       : 
		 *  ch=1    : 12.8k/16k/32k/64k/128k Hz
		 *  ch=2    : 12.8k/16k/32k/64k Hz
		 *  ch=3/4  : 12.8k/16k/32k Hz
		 * targetcnt         : 0 (continue mode)
		 */
		extriggMode=0;
		targetCnt=100;
		sampleRate=12800;
		ret=HS_SetAIScanParam(hHS, chCnt, useGain, extriggMode, sampleRate, targetCnt, DataTransMethod,AutoRun);
		//Step 2: SetScanParam sets chCnt, useGain, triggerMode, sampleRate, targetCnt to PET-AR400
		if(ret==false)
		{
			printf("Error code 0x%x\r\n",HS_GetLastError());
		}

		HS_GetAIScanParam(hHS, &chCnt, &useGain, &extriggMode, &sampleRate, &targetCnt,&DataTransMethod,&AutoRun); 
		//Step 3: GetScanParam getsx chCnt, useGain, triggerMode, sampleRate, targetCnt to check with PET-AR400
		printf("PET-AR400 first Scan parameters chCnt %d, useGain %d, triggMode %d, sampleRate %ld, targetCnt %lu \n", chCnt, useGain, extriggMode, sampleRate, targetCnt);

		Sleep(10);

		WORD BufferStatus=0;
		//#define BUFFERSIZE 29200
		//short *dataBuffer;
		float *fdataBuffer;
		unsigned long ulleng=0;
		unsigned long totalRecv=0;
		unsigned long readsize=0;	
		bool quit=false;

		/*Test N sample mode in this demo*/
		if(targetCnt>0) //N sample mode 
		{
			fdataBuffer=(float *)malloc(sizeof(float)*targetCnt);
			//Step 5: Start AI Scan
			DWORD t1=GetTickCount();
			//Step 4: Start AI Scan
			ret=HS_StartAIScan(hHS);
			if(ret==false)
			{
				printf("Error code 0x%x\r\n",HS_GetLastError());
			}

	
			//Step 5: while loop to get total received data from PET-AR400Logger
			while(quit==false)
			{			
				ret=HS_GetAIBufferStatus(hHS,&BufferStatus,&ulleng);
				if(ret==false)
				{
					printf("Error code 0x%x\r\n",HS_GetLastError());
				}
				else
				{
					if ((BufferStatus & 0x02) == 0x02 || (BufferStatus & 0x08) == 0x08)//AI buffer overflow
					{
						/* 
						   2:  AD_BUF_OVERFLOW	
						   4:  AD_SCAN_STOP
						   8:  AD_DATA_SAMPLING_TIMEOUT
						*/
						printf("Error<%d>, %lu\r\n",BufferStatus,ulleng);	
						break; 
					}
					if(ulleng==targetCnt)
					{
						//printf(">%d \r\n",ulleng);
						unsigned long size=targetCnt;	
						{													
							readsize=HS_GetAIBuffer(hHS,fdataBuffer,size);	
							
							if(readsize==targetCnt)
							{
								printf("%lu data\r\n",readsize);
								

								for(int i=0;i<readsize;i++)
								{	
									switch(i%chCnt)
									{
										case 3:
											printf("%lf\r\n",fdataBuffer[i]);
											break;
										default:
											printf("%lf,",fdataBuffer[i]);
											break;
									}
								}
							}
							else
							{
								printf("%d \r\n",readsize);
								printf("Get AI buffer error\r\n");
							}
						}
						break;
					}
				}
				//continue mode 
				if(_kbhit())
				{
					Sleep(1);
					if(_getch()=='q' || _getch()=='Q')
						break;
				}						
			}
		
			printf("AP total read %lu\n", readsize);
			//Step6: Stop AI Scan
			HS_StopAIScan(hHS);
			free(fdataBuffer);
		}
		//Step7: Close the connection
		HS_Device_Release(hHS);
	}
	return 0;

}

