// Analog_Input_Scan.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "HSDAQ.h"
#include <stdio.h>
#include <conio.h>


int _tmain(int argc, _TCHAR* argv[])
{
	HANDLE hHS;
	char IPadd[64]="\0";
	char sdk_version[16]={0};
	char fw_version[32]={0};

	bool ret= false;
	//short chCnt=8;
	//short  useGain=0;
	//short extriggMode=0;
	//bool continuousMode=false;
	//long continuousTimeout=0;


	if(argc>1)
	{
		wprintf(TEXT("%s\r\n"),argv[1]);
   
		//int   nLen   =   wcslen(argv[1])+1;    
		WideCharToMultiByte(CP_ACP,   0,   argv[1],   -1,   IPadd,  64,   NULL,   NULL);
		printf("program start %s\r\n",IPadd);
	}
	else
	{
		printf("error argument\r\n");
		return 0;
	}
	
	char tmp[128]={0};
	sprintf(tmp,"%s,9999,10010",IPadd);
	//Step 2: Create a TCP connection with ET-7H16
	hHS = HS_Device_Create(tmp);

	Sleep(10);
	if(hHS!=NULL)
	{
		printf("ET-7H16 Synchronous Input Scan Testing [continue mode & Software trigger]\r\n");
		HS_GetSDKVersion(sdk_version);
		printf("HSDAQ SDK Ver=%s\r\n",sdk_version);

		HS_GetFirmwareVersion(hHS,fw_version);
		printf("ET7H16 Firmware Ver=%s\r\n",fw_version);
		
		HS_GetHWFirmwareVersion(hHS,fw_version);
		printf("ET7H16 FPGA Firmware Ver=%s\r\n",fw_version);
	

		//Step 4: Set counter configuration
		DWORD dwCNTmode=CNT_ENABLE;
		DWORD dwCNTInitValue=0;
		DWORD nuse=0;
		HS_SetCounterConfig(hHS,0,dwCNTmode,dwCNTInitValue,0);
		Sleep(10);
		printf("HS_SetCounterConfig \r\n");
		//Step 5: Read counter configuration
		HS_GetCounterConfig(hHS,0,&dwCNTInitValue,&dwCNTInitValue, &nuse);
		printf("Counter parameters: Channel:%d, mode %d, Init value %d\r\n", 0, dwCNTmode, dwCNTInitValue);		


		unsigned long CNTvalue=0,CNTtempvalue=0;
		unsigned long CNTcheckerror=0;
		bool quit=false;
		int ind=0;

		//Step 7: while loop to get total received frame data count from PET-7H16
		while(quit==false)
		{			

			ret=HS_GetCounter(hHS,0,&CNTvalue);
			if(ret==false)
			{
				printf("Error code 0x%x\r\n",HS_GetLastError());
			}
			else
			{
				if(CNTtempvalue!=CNTvalue)
					printf("CNT 0x%ld\r\n",CNTvalue);
				else
				{
					switch(ind%4)
					{
						case 2:
						default:
							printf("-\r");
							break;
						case 1:						
							printf("\\r");
							break;
						case 3:
							printf("/\r");
							break;
					}
				}
				ind++;
			}

			//continue mode 
			if(_kbhit())
			{
				Sleep(1);
				if(_getch()=='c' || _getch()=='C')
					HS_ClearCounter(hHS,0);
				if(_getch()=='q' || _getch()=='Q')
					break;
			}						
		}

		printf("Read Counter End\r\n");
		HS_Device_Release(hHS);
	}
	return 0;

}

